﻿using System;
using System.Threading;
using System.Threading.Tasks;

namespace TestProject
{
    /// <summary>
    /// 프로그램
    /// </summary>
    class Program
    {
        //////////////////////////////////////////////////////////////////////////////////////////////////// Method
        ////////////////////////////////////////////////////////////////////////////////////////// Static
        //////////////////////////////////////////////////////////////////////////////// Private

        #region 프로그램 시작하기 - Main()

        /// <summary>
        /// 프로그램 시작하기
        /// </summary>
        /// <returns>태스크</returns>
        private static async Task Main()
        {
            Console.Title = "커스텀 태스크 사용하기";

            await CallAsync2();

            Console.WriteLine("비동기 호출 1 완료");

            await CallAsync1();

            Console.WriteLine("비동기 호출 2 완료");
        }

        #endregion

        #region 비동기 호출하기 1 - CallAsync1()

        /// <summary>
        /// 비동기 호출하기 1
        /// </summary>
        /// <returns>태스크</returns>
        private static Task CallAsync1()
        {
            return new TaskFactory().StartNew(() => { Thread.Sleep(5000); });
        }

        #endregion
        #region 비동기 호출하기 2 - CallAsync2()

        /// <summary>
        /// 비동기 호출하기 2
        /// </summary>
        /// <returns>태스크</returns>
        private static TestTask CallAsync2()
        {
            TestTask task = new TestTask(() =>
            {
                Thread.Sleep(5000);
            });

            return task;
        }

        #endregion
    }
}