﻿using System;
using System.Runtime.CompilerServices;

namespace TestProject
{
    /// <summary>
    /// 테스트 태스크 대기자
    /// </summary>
    public struct TestTaskAwaiter : ICriticalNotifyCompletion, INotifyCompletion
    {
        //////////////////////////////////////////////////////////////////////////////////////////////////// Field
        ////////////////////////////////////////////////////////////////////////////////////////// Private

        #region Field

        /// <summary>
        /// 태스크
        /// </summary>
        private TestTask task;

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Property
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region 완료 여부 - IsCompleted

        /// <summary>
        /// 완료 여부
        /// </summary>
        public bool IsCompleted
        {
            get
            {
                return this.task.IsCompleted;
            }
        }

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Constructor
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region 생성자 - TestTaskAwaiter(task)

        /// <summary>
        /// 생성자
        /// </summary>
        /// <param name="task">태스크</param>
        public TestTaskAwaiter(TestTask task)
        {
            this.task = task;
        }

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Method
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region 결과 구하기 - GetResult()

        /// <summary>
        /// 결과 구하기
        /// </summary>
        public void GetResult()
        {
        }

        #endregion
        #region 완료시 처리하기 - OnCompleted(continuationAction)

        /// <summary>
        /// 완료시 처리하기
        /// </summary>
        /// <param name="continuationAction">연결 액션</param>
        public void OnCompleted(Action continuationAction)
        {
            this.task.AddContinuation(continuationAction);
        }

        #endregion
        #region 비관리 완료시 처리하기 - UnsafeOnCompleted(continuationAction)

        /// <summary>
        /// 비관리 완료시 처리하기
        /// </summary>
        /// <param name="continuationAction">연결 액션</param>
        public void UnsafeOnCompleted(Action continuationAction)
        {
            this.task.AddContinuation(continuationAction);
        }

        #endregion
    }
}